# Ciao! UK music scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import convertArtist
from    jarray import zeros, array
from    java.lang import String


def extract():
    global title,artist,label,composer,date,copyDate,running,artistLF
    global value,valueDate,copies,upc,isbn,lccn,dewey,userNumber
    global format,series,sound,rating,condition,category
    global location,keywords,played,pflag,eflag,comments
    global dateEntered,dataSource,cart,ordered
    global diskCount,artistURL,conductor
    global trackTitles,trackArtists,trackWriters,trackTimes
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    sound               = "Stereo"
    format              = "CD"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    artistLF            = ""


    # Find marketplace pricing
    marketinfo = source


    # Main Extraction
    # Find Image
    i = string.find(source, "\"imgProd\"")

    if i != -1:
        image = searchForPlus(source, "\"imgProd\"")
        image = searchForPlus(image, "<img src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "/no_pic_")

        if i != -1:
            image = ""


    # Find Price
    i = string.find(source, "\"price2\"")

    if i != -1:
        value = searchForPlus(source, "\"price2\"")
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])

    i = string.find(source, ">Classical<")

    if i != -1:
        extractClassical()
    else:
        extractRock()




def extractRock():
    global title,artist,label,composer,date,copyDate,running,artistLF
    global value,valueDate,copies,upc,isbn,lccn,dewey,userNumber
    global format,series,sound,rating,condition,category
    global location,keywords,played,pflag,eflag,comments
    global dateEntered,dataSource,cart,ordered
    global diskCount,artistURL,conductor
    global trackTitles,trackArtists,trackWriters,trackTimes
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source

    # Find Title
    source = searchForPlus(source, "\"productdetail\"")
    source = searchForPlus(source, ">Title:")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Artist
    i = string.find(source, ">Performer:")

    if i != -1:
        source = searchForPlus(source, ">Performer:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])
        artist = convertArtist(artist)


    # Find Category
    i = string.find(source, ">Genre:")

    if i != -1:
        source = searchForPlus(source, ">Genre:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        category = stripText(source[0:i])

        i = string.find(source, ">Sub Genre:")

        if i != -1:
            source = searchForPlus(source, ">Sub Genre:")
            source = searchForPlus(source, ">")
            i = string.find(source, "<")
            category = category + " : " + stripText(source[0:i])


    # Find Release date
    i = string.find(source, ">Release Date:")

    if i != -1:
        source = searchForPlus(source, ">Release Date:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        date = stripText(source[0:i])

        if fullDateFormat == "false":
            i = string.rfind(date, "/")

            if i != -1:
                date = stripText(date[i+1:])


    # Find List price
    i = string.find(source, ">Recomended Retail Price:")

    if i != -1:
        source = searchForPlus(source, ">Recomended Retail Price:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        listprice = stripText(source[0:i])


    # Find Copyright date
    i = string.find(source, ">Original Release Year:")

    if i != -1:
        source = searchForPlus(source, ">Original Release Year:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        copyDate = stripText(source[0:i])


    # Find Label
    i = string.find(source, ">Label")

    if i != -1:
        source = searchForPlus(source, ">Label")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        label = stripText(source[0:i])

        i = string.find(label, " / ")

        if i != -1:
            label = stripText(label[0:i])


    # Find Sound
    i = string.find(source, ">Stereo:")

    if i != -1:
        source = searchForPlus(source, ">Stereo:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        sound = stripText(source[0:i])


    # Find UPC
    i = string.find(source, ">EAN:")

    if i != -1:
        source = searchForPlus(source, ">EAN:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        upc = stripText(source[0:i])


    # Find comments
    i = string.find(source, ">Additional notes<")

    if i != -1:
        source = searchForPlus(source, ">Additional notes<")
        source = searchForPlus(source, ">")
        i = string.find(source, "</td>")
        comments = stripText(source[0:i])

        i = string.find(comments, "<h4>Titles ")

        if i != -1:
            comments = stripText(comments[0:i])

        while (searchFor(comments, "\n") != None):
            i = string.find(comments, "\n")
            comments = comments[0:i] + comments[i+1:]

        comments = string.replace(comments, "<p>", "")
        comments = string.replace(comments, "</p>", "\n\n")
        comments = string.replace(comments, "<span>", "")
        comments = string.replace(comments, "</span>", "")


    # Find Tracks
    i = string.find(source, ">Titles on disc")

    if i != -1:
        source = searchFor(source, ">Titles on disc")
        i = string.find(source, "<h4>Ciao</h4>")
        disks = stripText(source[0:i])

        trackList = []
        artistList = []
        diskCount = 0

        while (searchFor(disks, "Titles on disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "Titles on disc ")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, "<h4>")
            tracks = stripText(disks[0:i])
            trackIndex = 1

            while (searchFor(tracks, ".: ") != None):
                tracks = searchForPlus(tracks, ".: ")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])
                trackid = "%02d" % trackIndex

                i = string.find(track, " - ")
                trackArtist = ""

                if (i != -1):
                    trackArtist = stripText(track[i+3:])
                    track = stripText(track[0:i])

                trackList.append(diskid + "-" + trackid + "-" + track)
                trackIndex = trackIndex + 1

        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)




def extractClassical():
    global title,artist,label,composer,date,copyDate,running,artistLF
    global value,valueDate,copies,upc,isbn,lccn,dewey,userNumber
    global format,series,sound,rating,condition,category
    global location,keywords,played,pflag,eflag,comments
    global dateEntered,dataSource,cart,ordered
    global diskCount,artistURL,conductor
    global trackTitles,trackArtists,trackWriters,trackTimes
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source

    # Find Title
    source = searchForPlus(source, "\"productdetail\"")
    source = searchForPlus(source, ">Title:")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Composer
    i = string.find(source, ">Composer:")

    if i != -1:
        composer = searchForPlus(source, ">Composer:")
        composer = searchForPlus(composer, ">")
        i = string.find(composer, "<")
        composer = stripText(composer[0:i])


    # Find Artist (Classical)
    i = string.find(source, ">Main Performer:")

    if i != -1:
        artist = searchForPlus(source, ">Main Performer:")
        artist = searchForPlus(artist, ">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])

        i = string.find(artist, "; ")

        if i != -1:
            artist = stripText(artist[0:i])


    # Find Release date
    i = string.find(source, ">Date of Release:")

    if i != -1:
        source = searchForPlus(source, ">Date of Release:")
        date = searchForPlus(source, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        if fullDateFormat == "false":
            i = string.rfind(date, "/")

            if i != -1:
                date = stripText(date[i+1:])


    # Find List price
    i = string.find(source, ">Recomended Retail Price:")

    if i != -1:
        listprice = searchForPlus(source, ">Recomended Retail Price:")
        listprice = searchForPlus(listprice, ">")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])


    # Find Copyright date
    i = string.find(source, ">Original Release Year:")

    if i != -1:
        copyDate = searchForPlus(source, ">Original Release Year:")
        source = searchForPlus(copyDate, ">")
        i = string.find(copyDate, "<")
        copyDate = stripText(copyDate[0:i])


    # Find Label
    i = string.find(source, ">Label")

    if i != -1:
        label = searchForPlus(source, ">Label")
        label = searchForPlus(label, ">")
        i = string.find(label, "<")
        label = stripText(label[0:i])

        i = string.find(label, " / ")

        if i != -1:
            label = stripText(label[0:i])


    # Find running time
    i = string.find(source, ">Running Time:")

    if i != -1:
        running = searchForPlus(source, ">Running Time:")
        running = searchForPlus(running, ">")
        i = string.find(running, "<")
        running = stripText(running[0:i])


    # Find Sound
    i = string.find(source, ">Stereo:")

    if i != -1:
        sound = searchForPlus(source, ">Stereo:")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])


    # Find UPC
    i = string.find(source, ">EAN:")

    if i != -1:
        upc = searchForPlus(source, ">EAN:")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])


    # Find Category
    i = string.find(source, ">Genre(s):")

    if i != -1:
        source = searchForPlus(source, ">Genre(s):")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        category = stripText(source[0:i])

        i = string.find(source, ">Genre(s):")

        if i != -1:
            source = searchForPlus(source, ">Genre(s):")
            source = searchForPlus(source, ">")
            i = string.find(source, "<")
            category = category + " : " + stripText(source[0:i])


    # Find comments
    i = string.find(source, ">Additional notes<")

    if i != -1:
        source = searchForPlus(source, ">Additional notes<")
        source = searchForPlus(source, ">")
        i = string.find(source, "</td>")
        comments = stripText(source[0:i])

        while (searchFor(comments, "\n") != None):
            i = string.find(comments, "\n")
            comments = comments[0:i] + comments[i+1:]

        comments = string.replace(comments, "<p>", "")
        comments = string.replace(comments, "</p>", "\n\n")
        comments = string.replace(comments, "<span>", "")
        comments = string.replace(comments, "</span>", "")


    # Find Tracks
    trackList = []
    artistList = []
    writerList = []
    diskCount = 1
    trackIndex = 1

    while (searchFor(source, ">Work Title:") != None):
        source = searchForPlus(source, ">Work Title:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<h4>")
        work = stripText(source[0:i])

        diskid = "%02d" % diskCount
        trackid = "%02d" % trackIndex

        i = string.find(work, "<")
        track = stripText(work[0:i])

        i = string.find(work, ">Composer:")

        if i != -1:
            writer = searchForPlus(work, ">Composer:")
            writer = searchForPlus(writer, ">")
            i = string.find(writer, "<")
            writer = stripText(writer[0:i])
        else:
            writer = ""

        i = string.find(work, ">Main Performer:")

        if i != -1:
            tartist = searchForPlus(work, ">Main Performer:")
            tartist = searchForPlus(tartist, ">")
            i = string.find(tartist, "<")
            tartist = stripText(tartist[0:i])

            i = string.find(tartist, ", ")

            if i != -1:
                tartist = stripText(tartist[0:i])
        else:
            tartist = ""

        trackList.append(diskid + "-" + trackid + "-" + track)
        writerList.append(diskid + "-" + trackid + "-" + writer)
        artistList.append(diskid + "-" + trackid + "-" + tartist)
        trackIndex = trackIndex + 1

    trackList.sort()
    trackTitles = array(trackList, String)
    artistList.sort()
    trackArtists = array(artistList, String)
    writerList.sort()
    trackWriters = array(writerList, String)




# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*




try:
    extract()
finally:
    if os.path.exists("scrapers/awuserexit.py"):
        execfile("scrapers/awuserexit.py") in globals()
