# Scraper user exit.
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.
#
# To activate this sample userexit script it must be renamed to
# userexit.py. If userexit.py exists it is called immediately 
# before the scraper process returns. You can change any of the 
# global variables to customize the extraction process.
# More info: http://www.readerware.com/help/rwCustomExtraction.html
#
#
# This sample script will generate a user number for each item 
# added/updated.

import  string
import  sys

def userextract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source
    global callnumber

    #
    # Sample script to assign a sequential number to each item
    #

    #
    # Pattern, the %d is where the sequential number will go, for
    # example:
    #
    #   "%d"            = 123
    #   "%05d"          = 00123
    #   SEQ%dB          = SEQ123B
    pattern = "ITEM%05d"

    #
    # The increment, defaults to 1
    incr = 1

    #
    # The current number is stored in the file "SEQ.TXT", get number
    # and update
    fname = "SEQ.TXT"

    try:
        cntFile = open(fname, 'r')
        num = cntFile.readline()
        num = string.atoi(num)
        num = num + incr
        cntFile.close()
    except:
        num = 1

    cntFile = open(fname, 'w')
    cntFile.write("%d\n" % num)
    cntFile.close()
    userNumber = pattern % num

userextract()
